package italo.comecome;

import italo.comecome.entrada.Entrada;
import italo.comecome.gui.desenho.DesenhoMenu;
import italo.comecome.gui.evento.EntradaMenu;
import italo.comecome.gui.figura.Figura;
import italo.comecome.logica.Jogo;

public class HandlerEntradaMenuJogo extends EntradaMenu {
		
	private final static String CAMINHO_MENU_OPCOES_OPCAO_INICIAL = Figura.CAMINHO_MENU+"2/1/";
	
	private HandlerEntradaMenuOpcoes handlerMO;
	private Entrada entrada;
	private DesenhoMenu desenhoMenu;
	private Jogo jogo;		
	
	private int opcao = 1;
	
	public HandlerEntradaMenuJogo(Entrada entrada, DesenhoMenu desenhoMenu, Jogo jogo) {
		this.handlerMO = new HandlerEntradaMenuOpcoes(this, entrada, desenhoMenu, jogo); 
		this.entrada = entrada;
		this.desenhoMenu = desenhoMenu;
		this.jogo = jogo;
		this.opcao = 1;
		desenhoMenu.desenhar(Figura.CAMINHO_MENU+opcao+Figura.EXT);
	}
	
	public void prabaixoPressionado() {		
		opcao = (opcao < 3 ? opcao+1 : 1);
		desenhoMenu.desenhar(Figura.CAMINHO_MENU+opcao+Figura.EXT);
	}

	public void pracimaPressionado() {
		opcao = (opcao > 1 ? opcao-1 : 3);
		desenhoMenu.desenhar(Figura.CAMINHO_MENU+opcao+Figura.EXT);
	}

	public void prafrentePressionado() {

	}

	public void pratrazPressionado() {
		
	}

	public void startPressionado() {		
		switch(opcao) {
			case 1:				
				entrada.removeTecladoListener(this);
				entrada.removeControlador1Listener(this);
				jogo.startar();	
				break;
			case 2:
				entrada.removeTecladoListener(this);
				entrada.removeControlador1Listener(this);
				entrada.addTecladoListener(handlerMO);
				entrada.addControlador1Listener(handlerMO);
				desenhoMenu.desenhar(CAMINHO_MENU_OPCOES_OPCAO_INICIAL+jogo.getDificuldade()+Figura.EXT);				
				break;
			case 3:
				jogo.sair();
				break;
		}
	}

}
