package italo.comecome.audio;

import italo.comecome.gui.ContainerJogo;
import italo.comecome.gui.desenho.CarregamentoIT;

import java.applet.AudioClip;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JApplet;

public class Audio {
	
	public final static String CAMINHO = "audio/";
	public final static String CAMINHO_FASE = "audio/fase/";
	public final static String CAMINHO_VIDA = "audio/vida/";
	public final static String EXT = ".wav";
	public final static String COMEU = "audio/comeu.wav";
	public final static String COMEUBG = "audio/comeubg.wav";
	public final static String OOH = "audio/ooh.wav";
	public final static String OOPS = "audio/oops.wav";
	public final static String GAMEOVER = "audio/gameover.wav";
	public final static String PASSOU = "audio/passou.wav";
	public final static String ZEROU = "audio/zerou.wav";
	public final static String RISADAMALIGNA = "audio/risadamaligna.wav";
	public final static String WOODY = "audio/woody.wav";	
	
	private Map<String, AudioClip> clips = new HashMap<String, AudioClip>();
	private ContainerJogo container;
	private String[] caminhos;
	
	public Audio(ContainerJogo container) {
		this.container = container;
	}
	
	public void inicializar(String[] caminhos) {
		this.caminhos = caminhos;
	}

	public void carregar(CarregamentoIT carregamento, int nArquivosMidia, int nArquivosCarregados) {
		int nArqCarregados = nArquivosCarregados;
		for(int i = 0; i < caminhos.length; i++) {
			clips.put(caminhos[i], novoAudioClip(caminhos[i]));
			carregamento.carregado(++nArqCarregados);
		}
	}
	
	public void playAudioClip(String caminho) {
		AudioClip clip;
		if(clips.containsKey(caminho)) {
			clip = clips.get(caminho);
		} else {
			clip = novoAudioClip(caminho);
		}
		playAudioClip(clip);
	}
	
	public AudioClip novoAudioClip(String caminho) {
		return JApplet.newAudioClip(container.getURL(caminho));
	}
	
	public void playAudioClip(AudioClip clip) {
		clip.play();
	}

	public String[] getCaminhos() {
		return caminhos;
	}

	public void setCaminhos(String[] caminhos) {
		this.caminhos = caminhos;
	}

}
