package italo.comecome.conf;

import italo.comecome.audio.Audio;
import italo.comecome.gui.figura.Figura;
import italo.comecome.logica.Fase;
import italo.comecome.logica.Jogo;
import italo.comecome.logica.Tabuleiro;
import italo.comecome.logica.TabuleiroException;
import italo.comecome.personagem.ComeCome;
import italo.comecome.personagem.Monstrinho;
import italo.comecome.personagem.Personagem;

import javax.swing.JOptionPane;

class Conf2 {
					
	private static Conf2 conf;
	
	public final static int N_VIDAS = 5;
	public final static int DIFICULDADE = 2;
	public final static int N_FASES = 5;
	public final static int N_BOLINHAS = 192;
	public final static int N_BOLINHAS_GRANDES = 4;
	
	private boolean[][] horizontalLivre = {
			{false, false, false, false, false, false, false, false, false, false, false, false},
			{true , false, false, true , false, true , true , false, true , false, false, true },
			{true , true , true , false, true , false, false, true , false, true , true , true },
			{true , true , false, false, true , false, false, true , false, false, true , true },
			{true , false, true , true , false, false, false, false, true , true , false, true },
			{true , false, true , true , false, false, false, false, true , true , false, true },
			{true , true , true , false, false, false, false, false, false, true , true , true },
			{true , true , true , false, true , false, false, true , false, true , true , true },
			{true , false, false, true , false, true , true , false, true , false, false, true },
			{false, false, false, false, false, false, false, false, false, false, false, false},
	};
	
	private boolean[][] verticalLivre = {
			{false, true , true , true , true , true , false, true , true , true , true , true , false},
			{false, true , true , true , false, true , false, true , false, true , true , true , false},
			{false, false, false, true , true , true , true , true , true , true , false, false, false},
			{false, true , false, true , true , true , true , true , true , true , false, true , false},
			{true , true , true , false, false, true , true , true , false, false, true , true , true },
			{false, true , false, true , true , true , true , true , true , true , false, true , false},
			{false, false, false, true , true , true , true , true , true , true , false, false, false},
			{false, true , true , true , false, true , false, true , false, true , true , true , false},
			{false, true , true , true , true , true , false, true , true , true , true , true , false},	
	};
	
	private boolean[][] bolinhas = {
			{true , true , true , true , true , true , true , true , true , true , true , false, true , true , true , true , true , true , true , true , true , true , true },
			{true , false, false, false, false, false, true , false, false, false, true , false, true , false, false, false, true , false, false, false, false, false, true },
			{true , true , true , true , true , true , true , false, true , true , true , false, true , true , true , false, true , true , true , true , true , true , true },
			{true , false, true , false, true , false, false, false, true , false, false, false, false, false, true , false, false, false, true , false, true , false, true },
			{true , false, true , false, true , true , true , true , true , true , true , true , true , true , true , true , true , true , true , false, true , false, true },
			{true , false, true , false, false, false, false, false, true , false, false, false, false, false, true , false, false, false, false, false, true , false, true },		
			{true , true , true , false, true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , false, true , true , true },
			{false, false, false, false, true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , false, false, false, false},
			{true , true , true , true , true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , true , true , true , true },
			{false, false, false, false, true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , false, false, false, false},
			{true , true , true , false, true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , false, true , true , true },
			{true , false, true , false, true , false, false, false, false, false, false, false, false, false, false, false, false, false, true , false, true , false, true },
			{true , false, true , false, true , true , true , true , true , true , true , true , true , true , true , true , true , true , true , false, true , false, true },
			{true , false, true , false, true , false, false, false, true , false, false, false, false, false, true , false, false, false, true , false, true , false, true },
			{true , true , true , true , true , true , true , false, true , true , true , false, true , true , true , false, true , true , true , true , true , true , true },
			{true , false, false, false, false, false, true , false, false, false, true , false, true , false, false, false, true , false, false, false, false, false, true },
			{true , true , true , true , true , true , true , true , true , true , true , false, true , true , true , true , true , true , true , true , true , true , true },
		};
			
	private int[][] bolinhasGrandes = { 
			{0 , 4},
			{0 , 18},
			{16, 4},
			{16, 18}	
	};
	
	private int[][] direcoesIniciaisMonstrinhos = {
		{Personagem.FRENTE, Personagem.FRENTE, Personagem.FRENTE, Personagem.FRENTE, Personagem.FRENTE, Personagem.FRENTE,Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA},
		{Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA},
		{Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA},
		{Personagem.TRAZ, Personagem.TRAZ, Personagem.TRAZ, Personagem.TRAZ, Personagem.TRAZ, Personagem.TRAZ, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA, Personagem.CIMA},
	};
	
	private int[][] posicaoCelulaInicialComeCome = { 
			{5, 6}  
	};
	
	private int[][] posicoesCelulasIniciaisMonstrinhos = {
			{4, 4},
			{5, 4}, 
			{6, 4}, 
			{7, 4}
	};
	
	private int[][] portas = {
			{4, 5},
			{4, 6}
	};
	
	public final static String[] CAMINHOS_IMAGENS = {
				
		// menus
		
		"img/menu/1.gif",
		"img/menu/2.gif",
		"img/menu/3.gif",
		"img/menu/2/1/1.gif",
		"img/menu/2/1/2.gif",
		"img/menu/2/1/3.gif",
		"img/menu/2/1/4.gif",
		"img/menu/2/2/1.gif",
		"img/menu/2/2/2.gif",
		"img/menu/2/2/3.gif",
		"img/menu/2/2/4.gif",
		
		// mensagens 
		
		"img/mensagens/vidas/1.gif",
		"img/mensagens/vidas/2.gif",
		"img/mensagens/vidas/3.gif",
		"img/mensagens/vidas/4.gif",
		"img/mensagens/gameover.gif",
		"img/mensagens/passou.gif",
		"img/mensagens/zerou.gif",
		"img/mensagens/pausa.gif",
		
		// tabuleiros
		
		"img/tabuleiro/2/1.gif", 
		"img/tabuleiro/2/2.gif",
		"img/tabuleiro/2/3.gif", 
		"img/tabuleiro/2/4.gif", 
		"img/tabuleiro/2/5.gif", 
		
		// comecome
		
		"img/comecome/frente/1.gif",
		"img/comecome/frente/2.gif",
		"img/comecome/frente/3.gif",
		"img/comecome/baixo/1.gif",
		"img/comecome/baixo/2.gif",
		"img/comecome/baixo/3.gif",
		"img/comecome/traz/1.gif",
		"img/comecome/traz/2.gif",
		"img/comecome/traz/3.gif",
		"img/comecome/cima/1.gif",
		"img/comecome/cima/2.gif",
		"img/comecome/cima/3.gif",
		
		// monstrinhos
		
		"img/monstrinhos/forte/1/1.gif",
		"img/monstrinhos/forte/1/2.gif",
		"img/monstrinhos/forte/1/3.gif",	
		"img/monstrinhos/forte/2/1.gif",
		"img/monstrinhos/forte/2/2.gif",
		"img/monstrinhos/forte/2/3.gif",
		"img/monstrinhos/forte/3/1.gif",
		"img/monstrinhos/forte/3/2.gif",
		"img/monstrinhos/forte/3/3.gif",
		"img/monstrinhos/forte/4/1.gif",
		"img/monstrinhos/forte/4/2.gif",
		"img/monstrinhos/forte/4/3.gif",
		"img/monstrinhos/forte/5/1.gif",
		"img/monstrinhos/forte/5/2.gif",
		"img/monstrinhos/forte/5/3.gif",
		"img/monstrinhos/forte/6/1.gif",
		"img/monstrinhos/forte/6/2.gif",
		"img/monstrinhos/forte/6/3.gif",
		
		"img/monstrinhos/fraco/1.gif",
		"img/monstrinhos/fraco/2.gif",
		"img/monstrinhos/fraco/3.gif",
		
		"img/monstrinhos/meiofraco/1.gif",
		"img/monstrinhos/meiofraco/2.gif",
		"img/monstrinhos/meiofraco/3.gif",
		
		"img/monstrinhos/muitofraco/1.gif",
		"img/monstrinhos/muitofraco/2.gif",
		"img/monstrinhos/muitofraco/3.gif",
		
	};
	
	private final static String[] CAMINHOS_SONS = {
		"audio/comeu.wav",	
		"audio/comeubg.wav",
		"audio/passou.wav",
		"audio/zerou.wav",
		"audio/gameover.wav",		
		"audio/ooh.wav",
		"audio/oops.wav",
		"audio/risadamaligna.wav",
		"audio/woody.wav",
		"audio/fase/1.wav",	
		"audio/fase/2.wav",
		"audio/fase/3.wav",
		"audio/fase/4.wav",
		"audio/fase/5.wav",
		"audio/vida/1.wav",
		"audio/vida/2.wav",
		"audio/vida/3.wav",
		"audio/vida/4.wav"
	};
	
	static {
		conf = new Conf2();
	}
	
	public static Conf2 getInstance() {
		return conf;
	}
	
	public void configurarJogo(Jogo jogo, Figura figura, Audio audio, int larguraCompleta, int alturaCompleta) {
		try {
			figura.inicializar(CAMINHOS_IMAGENS);
			audio.inicializar(CAMINHOS_SONS);
			Tabuleiro tabuleiro = new Tabuleiro(larguraCompleta, alturaCompleta, 20, 12, 9, new int[]{6, 5, 8, 4, 7});
			Fase[] fases = getFases(jogo, tabuleiro);
			jogo.setNVidas(N_VIDAS);
			jogo.setDificuldade(DIFICULDADE);
			jogo.setFases(fases);
		} catch(TabuleiroException e) {
			JOptionPane.showMessageDialog(null, e, "Falha na Configurao", JOptionPane.ERROR_MESSAGE);
		} catch(Exception e) {
			JOptionPane.showMessageDialog(null, e, "Falha na Configurao", JOptionPane.ERROR_MESSAGE);
		}
				
	}
		
	public Fase[] getFases(Jogo jogo, Tabuleiro tabuleiro) {		
		String[] caminhoTabuleiro = {"img/tabuleiro/2/1.gif", "img/tabuleiro/2/2.gif",
				"img/tabuleiro/2/3.gif", "img/tabuleiro/2/4.gif", "img/tabuleiro/2/5.gif"};
		Personagem comecome = new ComeCome(jogo, "comecome", 0, 40);		
		Personagem[][] monstrinhos = {			
			{new Monstrinho(jogo, "monstrinhos", 1, 60), new Monstrinho(jogo, "monstrinhos", 2, 70),	new Monstrinho(jogo, "monstrinhos", 3, 70),	new Monstrinho(jogo, "monstrinhos", 4, 60)},
			{new Monstrinho(jogo, "monstrinhos", 1, 50), new Monstrinho(jogo, "monstrinhos", 2, 60),	new Monstrinho(jogo, "monstrinhos", 3, 60),	new Monstrinho(jogo, "monstrinhos", 4, 50)},
			{new Monstrinho(jogo, "monstrinhos", 1, 40), new Monstrinho(jogo, "monstrinhos", 2, 50),	new Monstrinho(jogo, "monstrinhos", 3, 50),	new Monstrinho(jogo, "monstrinhos", 4, 40)},
			{new Monstrinho(jogo, "monstrinhos", 1, 35), new Monstrinho(jogo, "monstrinhos", 2, 45),	new Monstrinho(jogo, "monstrinhos", 3, 45),	new Monstrinho(jogo, "monstrinhos", 4, 35)},
			{new Monstrinho(jogo, "monstrinhos", 1, 30), new Monstrinho(jogo, "monstrinhos", 2, 40),	new Monstrinho(jogo, "monstrinhos", 3, 40),	new Monstrinho(jogo, "monstrinhos", 4, 30)}
		};
		Fase[] fases = new Fase[N_FASES];
		for(int i = 0; i < fases.length; i++) {
			fases[i] = new Fase(comecome, monstrinhos[i], tabuleiro, caminhoTabuleiro[i], i);
			fases[i].setNumero(i+1); 
			fases[i].setNBolinhasIniciais(N_BOLINHAS);
			fases[i].setNBolinhasGrandesIniciais(N_BOLINHAS_GRANDES);			
			fases[i].setHorizontalLivre(horizontalLivre);
			fases[i].setVerticalLivre(verticalLivre);
			fases[i].setBolinhasIniciais(bolinhas);
			fases[i].setBolinhasGrandesIniciais(bolinhasGrandes);
			fases[i].setDirecoesIniciaisMonstrinhos(direcoesIniciaisMonstrinhos);
			fases[i].setIndicesPortas(portas);
			fases[i].setPosicaoCelulaInicialComecome(posicaoCelulaInicialComeCome);
			fases[i].setPosicoesCelulasIniciaisMonstrinhos(posicoesCelulasIniciaisMonstrinhos);
		}
		return fases;
	}

					
}
