package italo.comecome.entrada;

import java.util.ArrayList;
import java.util.List;

import com.centralnexus.input.Joystick;
import com.centralnexus.input.JoystickListener;

class Controlador implements JoystickListener {
	
	private Joystick joystick;
	
	private List<JoystickListener> listeners = new ArrayList<JoystickListener>();
	
	public Controlador(Joystick joystick) {
		this.joystick = joystick;
	}
	
	public void addJoystickListenerControlador(JoystickListener listener) {
		listeners.add(listener);	
	}
	
	public void removeJoystickListenerControlador(JoystickListener listener) {
		listeners.remove(listener);	
	}
	
	public void addJoystickListener() {
		joystick.addJoystickListener(this);	
	}
	
	public void removeJoystickListener() {
		joystick.removeJoystickListener(this);
	}

	public void joystickAxisChanged(Joystick e) {
		for(int i = 0; i < listeners.size(); i++)
			listeners.get(i).joystickAxisChanged(e);		
	}

	public void joystickButtonChanged(Joystick e) {
		for(int i = 0; i < listeners.size(); i++)
			listeners.get(i).joystickButtonChanged(e);		
	}

}
