package italo.comecome.gui.desenho;

import italo.comecome.gui.ContainerJogo;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.image.ImageObserver;

public class DesenhoConcreto implements Desenho {
		
	private final static int FATOR_LARGURA = 40;
	private final static int FATOR_ALTURA = 30;
		
	private String caminho;
	private ContainerJogo container;
		
	public DesenhoConcreto(ContainerJogo container, String caminho) {
		this.caminho = caminho;
		this.container = container;
	}
		
	public void desenhar(Graphics g) {	
		Image imagem = container.getImage(caminho);
		if(imagem != null) {
			MediaTracker tracker = new MediaTracker(container.getPainelPersonalizado());
			tracker.addImage(imagem, 0);
			try {
				tracker.waitForID(0);
			} catch(InterruptedException e) {
			
			}
			int x = container.getContainer().getInsets().left+(FATOR_LARGURA/2);
			int y = container.getContainer().getInsets().top+(FATOR_ALTURA/2);
			int largura = container.getContainer().getSize().width-FATOR_LARGURA;
			int altura = container.getContainer().getSize().height-FATOR_ALTURA;
			ImageObserver imgObserver = container.getPainelPersonalizado();
			g.drawImage(imagem, x, y, largura, altura, imgObserver);
		}
		
	}
		
}