package italo.comecome.gui.desenho;

import italo.comecome.gui.ContainerJogo;
import italo.comecome.gui.PainelPersonalizado;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;

public class DesenhoMenu implements Desenho{

	private final static double FATOR_LARGURA = 0.5;
	private final static double FATOR_ALTURA = 0.25;

	private ContainerJogo container;
	private PainelPersonalizado painelPersonalizado;
	private String caminho;
	
	public DesenhoMenu(ContainerJogo container) {
		this.container = container;
		this.painelPersonalizado = container.getPainelPersonalizado();
	}
	
	public void desenhar(String caminho) {
		setCaminho(caminho);
		painelPersonalizado.desenhar(this);
	}

	public void desenhar(Graphics g) {
		container.getFundo().desenhar(g);
		Insets i = container.getContainer().getInsets();
		Dimension size = container.getContainer().getSize();
		int largura = (int)(size.width*FATOR_LARGURA);
		int altura = (int)(size.height*FATOR_ALTURA);	
		int x = i.left+((size.width-largura)/2);
		int y = i.top+((size.height-altura)/2);			
		Image imagem = container.getFigura().getImage(caminho);
		g.drawImage(imagem, x, y, largura, altura, painelPersonalizado);
	}

	public String getCaminho() {
		return caminho;
	}

	public void setCaminho(String caminho) {
		this.caminho = caminho;
	}
	
}
