package italo.comecome.gui.evento;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import com.centralnexus.input.Joystick;
import com.centralnexus.input.JoystickListener;

public abstract class EntradaMenu implements KeyListener, JoystickListener {

	private boolean altPressionado = false;
			
	public void keyPressed(KeyEvent e){
		if(e.getKeyCode() == KeyEvent.VK_LEFT) {
			pratrazPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_RIGHT) {
			prafrentePressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_DOWN) {
			prabaixoPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_UP) {
			pracimaPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ENTER) {
			if(!altPressionado)
				startPressionado();
		} else if(e.getKeyCode() == KeyEvent.VK_ALT) {
			altPressionado = true;
		}
	}
	
	public void keyReleased(KeyEvent e){
		altPressionado = false;
	}
	
	public void keyTyped(KeyEvent e) {}

	public void joystickAxisChanged(Joystick j) {
		if(j.getX() == -1) {
			pratrazPressionado();
		} else if(j.getX() == 1) {
			prafrentePressionado();
		} else if(j.getY() == -1) {
			pracimaPressionado();
		} else if(j.getY() == 1) {
			prabaixoPressionado();
		}
	}

	public void joystickButtonChanged(Joystick j) {
		if(j.getButtons() == Joystick.BUTTON9) {			
			startPressionado();
		}
	}

	public abstract void prafrentePressionado();
	public abstract void pratrazPressionado();
	public abstract void prabaixoPressionado();
	public abstract void pracimaPressionado();
	public abstract void startPressionado();
	
}

