package italo.comecome.gui.figura;

import italo.comecome.gui.ContainerJogo;
import italo.comecome.gui.desenho.CarregamentoIT;

import java.awt.Image;
import java.awt.MediaTracker;
import java.util.HashMap;
import java.util.Map;

import javax.swing.JPanel;

class ConjuntoFigura {

	private Map<String, Image> imagens = new HashMap<String, Image>();
	private String[] caminhos = null;
	private ContainerJogo container;
	
	public ConjuntoFigura(ContainerJogo container, String[] caminhos) {			
		this.caminhos = caminhos;		
		this.container = container;
	}
	
	public void carregarImagens(CarregamentoIT carregamento, int nArquivosMidia, int nArquivosCarregados) {
		MediaTracker tracker = new MediaTracker(new JPanel());
		int nArqCarregados = nArquivosCarregados;
		for(int i = 0; i < caminhos.length; i++) {
			String caminho = caminhos[i];
			carregarImagem(caminho, tracker, i);			
			carregamento.carregado(++nArqCarregados); 
		}		
	}
	
	public void carregarImagens() {
		MediaTracker tracker = new MediaTracker(new JPanel());
		for(int i = 0; i < caminhos.length; i++) {
			String caminho = caminhos[i];
			carregarImagem(caminho, tracker, i);			
		}		
	}
			
	private void carregarImagem(String caminho, MediaTracker tracker, int id) {
		Image img = container.getImage(caminho);
		if(img != null) {
			tracker.addImage(img, id);
			try {
				tracker.waitForID(id);
			} catch (InterruptedException e) {
				
			}
			imagens.put(caminho, img);
		}			
	}

	public Image getImagem(String caminho) {
		if(imagens.containsKey(caminho)) {
			return imagens.get(caminho);
		} else {
			Image img = container.getImage(caminho);
			imagens.put(caminho, img); 
			return img;
		}
	}
	
	public int getNumeroFiguras() {
		return (caminhos != null ? caminhos.length : -1); 
	}
	
}
