package italo.comecome.logica;

public class TabuleiroException extends Exception {

	private static final long serialVersionUID = 1L;

	private Tabuleiro tabuleiro;
	
	public TabuleiroException(Tabuleiro tabuleiro) {
		this.tabuleiro = tabuleiro;
	}
	
	public String toString() {
		return "\t("+tabuleiro.getLarguraCompleta()+" x "+tabuleiro.getAlturaCompleta()+")\n" +
			"\nLargura ............: "+tabuleiro.getLarguraTabuleiro() +
			"\nAltura .............: "+tabuleiro.getAlturaTabuleiro() +
			"\nLargura Celula .....: "+tabuleiro.getLarguraCelula() +
			"\nAltura Celula ......: "+tabuleiro.getAlturaCelula() +
			"\nLargura MiniCelula .: "+tabuleiro.getLarguraMiniCelula() +
			"\nAltura MiniCelula ..: "+tabuleiro.getAlturaMiniCelula();
	}

}
