package italo.comecome.personagem;

import italo.comecome.logica.Fase;
import italo.comecome.logica.Jogo;

public class ComeCome extends Personagem {
	
	private ComeComeIT comecomeIT = new ComeComeIMP(jogo);	
	private boolean parar = false;	
	
	public ComeCome(Jogo jogo, String nome, int id, int sleep) {
		super(jogo, nome, id, sleep);	
	}

	public void executar() {
		boolean ganhou = false;
		boolean perdeu = false;			
		while(!ganhou && !perdeu) {		
			while(parar) 
				esperar();
			perdeu = comecomeIT.monstrinhoPegou(this);
			if(!perdeu) {
				comecomeIT.mover(this);
				comecomeIT.comer(this);
				if(!parar)
					comecomeIT.dormir(this);
				ganhou = comecomeIT.ganhou(this);
			}								
		}			
		finalizar(ganhou);
	}
			
	public boolean podeMover() {		
		Fase fase = jogo.getFaseAtual();		
		if(fase == null) 
			return false;
		return fase.podeMover(this);					
	}
	
	public void iniciar() {
		direcao = FRENTE;
		novaDirecao = FRENTE;
	}
	
	private void finalizar(boolean ganhou) {
		jogo.getFaseAtual().finalizar();
		if(ganhou) {
			jogo.passou();
		} else {
			jogo.perdeu();
		}
	}
	
	public void pararExecucao() {
		parar = true;
	}
	
	public void continuarExecucao() {
		parar = false;
		notificar();
	}
	
	public synchronized void notificar() {
		notify();
	}
	
	private synchronized void esperar() {
		try {
			wait();
		} catch(InterruptedException e) {
			
		}
	}
	
}
